using System;
using System.Net.Sockets;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;

using AnimalLibrary;

class AnimalSender
{
	const string SERVER_HOSTNAME = "localhost";
	const int SERVER_PORT = 10000;

	static void Main(string[] args)
	{
		Animal animal = new Animal();
		animal.Name = "My fluffy cat";
		animal.Claws = new Claws("Sharp beautiful claws");
		animal.Eyes = new Eye[]
		{
            new Eye("Left eye", 1.05), 
			new Eye("Right eye", 0.95) 
		};

		TcpClient tcpClient = new TcpClient(SERVER_HOSTNAME, SERVER_PORT);
		try
		{
			IFormatter formatter = new BinaryFormatter();
			NetworkStream stream = tcpClient.GetStream();
			using (stream)
			{
				formatter.Serialize(stream, animal);
			}
			Console.WriteLine("Sent animal: {0}", animal);
		}
		finally
		{
			tcpClient.Close();
		}
	}
}
