using System;
using System.IO;
using System.Xml.Serialization;

public class Person
{
	public string Name;
	public int Age;
	public string[] Friends;
}

class OverridingXmlSerializationDemo
{
	static void Main()
	{
		Person person = new Person();
		person.Name = "Бай Мангал";
		person.Age = 82;
		person.Friends = new string[] {"Дядо Мраз", "Баба Яга"};

		XmlAttributeOverrides overrides = new XmlAttributeOverrides();

		XmlAttributes nameAttributes = new XmlAttributes();
		XmlElementAttribute nameElement = new XmlElementAttribute("PersonName");
		nameAttributes.XmlElements.Add(nameElement);
		overrides.Add(typeof(Person), "Name", nameAttributes);

		XmlAttributes friendsAttributes = new XmlAttributes();
		XmlArrayAttribute friendsArray = new XmlArrayAttribute("PersonFriends");
		friendsAttributes.XmlArray = friendsArray;
		XmlArrayItemAttribute friendsArrayItem = new XmlArrayItemAttribute();
		friendsArrayItem.ElementName = "FriendName";
		friendsAttributes.XmlArrayItems.Add(friendsArrayItem);
		overrides.Add(typeof(Person), "Friends", friendsAttributes);

		TextWriter writer = new StreamWriter("person.xml");
		using (writer)
		{
			XmlSerializer xmlSer = new XmlSerializer(typeof(Person), overrides);
			xmlSer.Serialize(writer, person);
		}
		Console.WriteLine("Person instance serialized.");
	}
}
